dofile( "data/scripts/lib/utilities.lua" )

function take_gold( cost )
    local player = get_players()[1]
    local walletComponent = EntityGetFirstComponent( player, "WalletComponent" )

	if( walletComponent ~= nil ) then 
        moneyCurrent = tonumber( ComponentGetValue( walletComponent, "money" ) )
        
        if(cost > moneyCurrent) then
            return false
        else
            local newMoney = (moneyCurrent - cost)
            ComponentSetValue(walletComponent, "money", newMoney)
        end
	end

    return true
end


function is_affordable( cost )
    local player = get_players()[1]
    local walletComponent = EntityGetFirstComponent( player, "WalletComponent" )

	if( walletComponent ~= nil ) then 
        moneyCurrent = tonumber( ComponentGetValue( walletComponent, "money" ) )
        
        if(cost > moneyCurrent) then
            return false
        end
	end

    return true
end

function get_closest_enemy_in_range(self_entity, x, y, range)

	local enemySprites = {
		"data/enemies_gfx/acidshooter.xml",
		"data/enemies_gfx/acidshooter_weak.xml",
		"data/enemies_gfx/alchemist.xml",
		"data/enemies_gfx/angler_body.xml",
		"data/enemies_gfx/angler_head.xml",
		"data/enemies_gfx/ant.xml",
		"data/enemies_gfx/assassin.xml",
		"data/enemies_gfx/assassin_emissive.xml",
		"data/enemies_gfx/barfer.xml",
		"data/enemies_gfx/bat.xml",
		"data/enemies_gfx/bigbat.xml",
		"data/enemies_gfx/bigfirebug.xml",
		"data/enemies_gfx/bigfirebug_emissive.xml",
		"data/enemies_gfx/bigzombie.xml",
		"data/enemies_gfx/bigzombiehead.xml",
		"data/enemies_gfx/bigzombietorso.xml",
		"data/enemies_gfx/blob.xml",
		"data/enemies_gfx/blob_emissive.xml",
		"data/enemies_gfx/bloom.xml",
		"data/enemies_gfx/crawler.xml",
		"data/enemies_gfx/crystal.xml",
		"data/enemies_gfx/darkghost.xml",
		"data/enemies_gfx/darkghost_skull.xml",
		"data/enemies_gfx/dragon_body.xml",
		"data/enemies_gfx/dragon_head.xml",
		"data/enemies_gfx/dragon_tail.xml",
		"data/enemies_gfx/endworm_head.xml",
		"data/enemies_gfx/endworm_middle.xml",
		"data/enemies_gfx/endworm_tail.xml",
		"data/enemies_gfx/firebug.xml",
		"data/enemies_gfx/firebug_emissive.xml",
		"data/enemies_gfx/firemage.xml",
		"data/enemies_gfx/firemage_weak.xml",
		"data/enemies_gfx/fireskull.xml",
		"data/enemies_gfx/flamer.xml",
		"data/enemies_gfx/fungus.xml",
		"data/enemies_gfx/fungus_big.xml",
		"data/enemies_gfx/gazer.xml",
		"data/enemies_gfx/ghost.xml",
		"data/enemies_gfx/ghoul.xml",
		"data/enemies_gfx/giant.xml",
		"data/enemies_gfx/giantshooter.xml",
		"data/enemies_gfx/giantshooter_weak.xml",
		"data/enemies_gfx/healerdrone_emissive.xml",
		"data/enemies_gfx/icer.xml",
		"data/enemies_gfx/iceskull.xml",
		"data/enemies_gfx/lasershooter.xml",
		"data/enemies_gfx/lasershooter_emissive.x",
		"data/enemies_gfx/longleg.xml",
		"data/enemies_gfx/lurker.xml",
		"data/enemies_gfx/maggot.xml",
		"data/enemies_gfx/mine.xml",
		"data/enemies_gfx/miner.xml",
		"data/enemies_gfx/miner_fire.xml",
		"data/enemies_gfx/miner_santa.xml",
		"data/enemies_gfx/miner_weak.xml",
		"data/enemies_gfx/mine_emissive.xml",
		"data/enemies_gfx/miniblob.xml",
		"data/enemies_gfx/miniblob_emissive.xml",
		"data/enemies_gfx/missilecrab.xml",
		"data/enemies_gfx/missilecrab_emissive.xm",
		"data/enemies_gfx/necromancer.xml",
		"data/enemies_gfx/necromancer_shop.xml",
		"data/enemies_gfx/necromancer_shop_emissi",
		"data/enemies_gfx/peasant.xml",
		"data/enemies_gfx/phantom_a.xml",
		"data/enemies_gfx/phantom_b.xml",
		"data/enemies_gfx/rat.xml",
		"data/enemies_gfx/roboguard.xml",
		"data/enemies_gfx/scavenger_clusterbomb.x",
		"data/enemies_gfx/scavenger_grenade.xml",
		"data/enemies_gfx/scavenger_heal.xml",
		"data/enemies_gfx/scavenger_leader.xml",
		"data/enemies_gfx/scavenger_mine.xml",
		"data/enemies_gfx/scavenger_poison.xml",
		"data/enemies_gfx/scavenger_smg.xml",
		"data/enemies_gfx/scorpion.xml",
		"data/enemies_gfx/sheep.xml",
		"data/enemies_gfx/sheep_bat.xml",
		"data/enemies_gfx/sheep_fly.xml",
		"data/enemies_gfx/shooterflower.xml",
		"data/enemies_gfx/shotgunner.xml",
		"data/enemies_gfx/shotgunner_weak.xml",
		"data/enemies_gfx/skullfly.xml",
		"data/enemies_gfx/skullrat.xml",
		"data/enemies_gfx/slimeshooter.xml",
		"data/enemies_gfx/slimeshooter_weak.xml",
		"data/enemies_gfx/sniper.xml",
		"data/enemies_gfx/spitmonster.xml",
		"data/enemies_gfx/statue_physics_emissive",
		"data/enemies_gfx/tank.xml",
		"data/enemies_gfx/tank_emissive.xml",
		"data/enemies_gfx/tank_gun.xml",
		"data/enemies_gfx/tank_rocket.xml",
		"data/enemies_gfx/tank_rocket_gun.xml",
		"data/enemies_gfx/tank_super.xml",
		"data/enemies_gfx/tank_super_emissive.xml",
		"data/enemies_gfx/tank_super_gun.xml",
		"data/enemies_gfx/tentacler.xml",
		"data/enemies_gfx/tentacler_small.xml",
		"data/enemies_gfx/thundermage.xml",
		"data/enemies_gfx/thundermage_emissive.xm",
		"data/enemies_gfx/turret.xml",
		"data/enemies_gfx/turret_emissive.xml",
		"data/enemies_gfx/wizard_dark.xml",
		"data/enemies_gfx/wizard_dark_emissive.xm",
		"data/enemies_gfx/wizard_poly.xml",
		"data/enemies_gfx/wizard_poly_emissive.xm",
		"data/enemies_gfx/wizard_tele.xml",
		"data/enemies_gfx/wizard_tele_emissive.xm",
		"data/enemies_gfx/worm_big_body.xml",
		"data/enemies_gfx/worm_big_head.xml",
		"data/enemies_gfx/worm_big_tail.xml",
		"data/enemies_gfx/worm_body.xml",
		"data/enemies_gfx/worm_head.xml",
		"data/enemies_gfx/worm_skull_body.xml",
		"data/enemies_gfx/worm_skull_head.xml",
		"data/enemies_gfx/worm_skull_tail.xml",
		"data/enemies_gfx/worm_tail.xml",
		"data/enemies_gfx/worm_tiny_body.xml",
		"data/enemies_gfx/worm_tiny_head.xml",
		"data/enemies_gfx/worm_tiny_tail.xml",
		"data/enemies_gfx/wraith.xml",
		"data/enemies_gfx/wraith_arm.xml",
		"data/enemies_gfx/wraith_glowing.xml",
		"data/enemies_gfx/zombie.xml",
		"data/enemies_gfx/zombie_emissive.xml",
		"data/enemies_gfx/zombie_weak.xml"	
	}

	--local radiusEntities = EntityGetInRadius( x, y, range )
	local radiusEntities = EntityGetInRadiusWithTag( x, y, range, "teleportable_NOT" )

	ourEntities = {}
	for k, i in ipairs(radiusEntities) do

		local transformX, transformY = EntityGetTransform(i)
		if(transformX ~= nil)then
			local spriteComponent = EntityGetComponent(i, "SpriteComponent")
			
			if(spriteComponent ~= nil)then
				local spriteComponentOne = spriteComponent[1]
				local spriteXML = ComponentGetValue( spriteComponentOne, "image_file" )
				for index, value in ipairs(enemySprites) do
					if value == spriteXML then

						if(i ~= self_entity)then
							table.insert(ourEntities, i)

						end

					end	
				end
			end	
		end
	end

	local smallest, smallestIndex, smallestEntity
	for i, theEntity in ipairs(ourEntities) do
		local zX, zY = EntityGetTransform(theEntity)
		
		local dx = x - zX
		local dy = y - zY
		local distance = math.sqrt ( dx * dx + dy * dy )
		
		
		if not smallest or (distance < smallest) then
			
			smallest = distance
			smallestEntity = theEntity
			smallestIndex = i
		end
	end
	if(smallest ~= nil)then
		if(smallest < range)then
			return smallestEntity
		else	
			return nil
		end
	else
		return nil
	end
end

function shoot_at_entity(self_entity, target_entity, general_offset, x_offset, y_offset, speed, projectile, maxdistance)
	--print(tostring(closestEntity))
	local x, y = EntityGetTransform(self_entity)
	
	if(target_entity ~= nil)then
		local entityX, entityY = EntityGetTransform( target_entity )
		local headingX = entityX - x
		local headingY = (entityY-5) - y
		
		local len = math.sqrt((headingX*headingX) + (headingY*headingY))

		local directionX = headingX / len
		local directionY = headingY / len		
		
		local didHit, hitX, hitY = Raytrace( x, y, entityX, entityY )
		
		--
		
		--if(didHit == true)then
			local headingHitX = entityX - hitX
			local headingHitY = entityY - hitY
			
			local hitDistance = math.sqrt((headingHitX*headingHitX) + (headingHitY*headingHitY))

			--DEBUG_MARK( hitX, hitY, hitDistance, 1, 0, 0 )
			
			local pos_x, pos_y, currentRotation = EntityGetTransform( self_entity )

				
					
			if(directionX < 0)then
				EntitySetTransform(self_entity,pos_x,pos_y,currentRotation,-1,1)
			else
				EntitySetTransform(self_entity,pos_x,pos_y,currentRotation,1,1)
			end
			
			
			if(hitDistance < maxdistance)then
				local ourProjectile = shoot_projectile( self_entity, projectile, x + (directionX * general_offset) + x_offset, y + (directionY * general_offset) + y_offset, directionX * speed, directionY * speed )
				edit_component( ourProjectile, "ProjectileComponent", function(comp,vars)
					vars.mWhoShot       = self_entity
					vars.mShooterHerdId = "player"
				end)
			end
		--end
	end
end